<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta http-equiv="X-UA-Compatible" content="ie=edge">
        <title>Routing Navigator</title>
        <style>
            * { box-sizing: border-box; }
          
            :root{
                --header-height:20vh;
                --footer-height:15vh;
                --content-height: 75vh;
                --main-height: var(--content-height);
                --aside-height: var(--content-height);

                font-family: sans-serif;
            }
            
            ul {
                list-style-type: none;
                margin: 0;
                padding: 0;
                overflow: hidden;
                background-color: #333333;
            }

            div.header ul li div.button 
            {
                float: left;
            }

            div.button {
                display: block;
                color: white;
                text-align: center;
                padding: 16px;
                text-decoration: none;
            }

            div.button:hover {
                background-color: #111111;
                cursor: pointer;
            }

            .container {
                display: flex;
                flex-wrap: wrap;
            }

            .column
            {
                border-style: solid;
                border-color: white;
                border-width: 4px;
            }

            h2 {
                text-align: center;
            }

            .header {
                width: 100%;
            }

            .menu {
                width: 20%;            
            }

            .main {
                border-left: solid gray 1px;
                border-right: solid gray 1px;
                padding: 1em;
                width: 60%;         
                text-align: justify;
                min-height: var(--main-height);       
            }

            .aside {
                width: 20%;   
                padding: 1em;      
            }

            .footer {
                width: 100%;
                color: white;
                background: #333333;
                padding: 1em;
                min-height: var(--footer-height);       
            }


            @media screen and (max-width: 900px) {
                :root{
                    --content-height: 90vh;
                }
                .aside {
                    width: 100%;      
                    border-top: solid black 1px;
                }
                .menu {
                    width: 30%;         
                }
                .main {
                    width: 70%;         
                    border-right: solid white 4px;
                }
            }

            @media screen and (max-width: 450px) {
                .main, .menu {
                    width: 100%;         
                    border: solid white 4px;
                }
            }

        </style>
    </head>
    <body>
        <div class="container">
            <div class="header column">
                <h2>WWW-Navigator</h2>    
                <ul></ul>
            </div>
            <div class="menu column"><ul></ul></div>
            <div class="main column"></div>
            <div class="aside column"></div>
            <div class="footer column">Dieses Programm dient dazu verschiedene Funktionalitäten von HTML, CSS und JavaScript für den Anwender leicht zugänglich zu machen.</div>
        </div>
        <script>
            const uri1 = "../06-ASYNC/Navigator.json"
            const headerlist = document.querySelector('div.header ul');
            const menulist = document.querySelector('div.menu ul');
            const textField = document.querySelector('div.main');
            const aside = document.querySelector('div.aside');

            function loadUrl(state) {
                console.log(state);
                createNavButtons(state);
                textField.innerHTML = state.mainText;
                aside.innerHTML = state.asideText;
            }

            function push(data, mainText, asideText, url) {
                console.log("push");
                const pushObject = Object.assign(data, {mainText: mainText, asideText: asideText});
                history.pushState(pushObject, null, url);
            }

            window.onpopstate = function(event) {
                loadUrl(history.state);
            }
            
            const fetchData = async () => 
            {
                const response = await Promise.all([fetch(uri1)]);                
                const content = JSON.parse(await Promise.all([response[0].text()]));         
                push([], "","", `Routing.html`);

                createMenuButtons(content);
            }

            const createMenuButtons = (data) => {
                data.forEach(element => {
                    createListItem(headerlist, element.toptheme, () => 
                    {
                        const mainText = element.description;
                        const asideText = `<a href="${element.url}" target="_blank">Weiter führende Links</a>`;
                        push(element.subthemes, mainText, asideText, `${element.toptheme}.html`);

                        textField.innerHTML = mainText;
                        aside.innerHTML = asideText;
                        
                        createNavButtons(element.subthemes);
                    });
                });
            }

            const removeNavButtons = () => {
                var child = menulist.firstElementChild;
                while (child)
                {
                    menulist.removeChild(child);
                    child = menulist.firstElementChild;
                }
            }

            const createNavButtons = (data) => {
                removeNavButtons();
                data.forEach(element => {
                    createListItem(menulist, element.subtheme, () =>
                    {
                        const mainText = element.description;
                        const asideText = `<a href="${element.url}" target="_blank">Weiter führende Links</a>`;
                        push(data, mainText, asideText, `${element.subtheme}.html`);
                        textField.innerHTML = mainText;
                        aside.innerHTML = asideText;
                    });
                });
            }

            const createListItem = (list, theme, func) => 
            {
                const listItem = document.createElement('li');
                list.appendChild(listItem);
                listItem.innerHTML = `<div class="button">${theme}</div>`;
                const button = listItem.querySelector('div');
                button.onclick = () => func();
            }

            fetchData();

        </script>
    </body>
</html>